Overview | Modules | Class Hierarchy | Classes | Members

Public Member Functions
tlp::PluginInfoInterface Class Reference
Plugins

Base interface for plug-in description. This class is not intented to be subclassed by plug-ins themselves, but by the factories who create the plug-ins. This class holds user informations, such as name of the author, date of creation, and miscellaneous informations. It also holds informations for the Tulip plug-in system, such as the version (used to know when there is an update for a plug-in), the name (used as unique identifier to register the plug-in), the Tulip version the plug-in was built with (to know whether the plug-in is compatible with the currently running version of TUlip), and the group this plug-in belongs to (e.g. trees). More...

`#include <Plugin.h>`

Inheritance diagram for tlp::PluginInfoInterface:
[legend]

List of all members.

## Public Member Functions

- virtual ~PluginInfoInterface ()
- virtual std::string getName () const =0
    Returns the name of the plug-in, as registered in the Tulip plug-in system. This name must be unique, and if multiple plug-ins have the same name, only the latest encountered will be considered.
- virtual std::string getGroup () const =0
    Returns the name of the group this plug-in belongs to. Groups and sub-groups are separated by two colons. e.g. trees::planar trees.
- virtual std::string getAuthor () const =0
    The name of the author of this plug-in.
- virtual std::string getDate () const =0
    The creation date of the plug-in. This date is in a free format, but most Tulip plug-ins use a DD/MM/YYYY.
- virtual std::string getInfo () const =0
    Informations about the plug-in, from the plug-in author. These informations can contains anything, and the developer is completely free to put anything here. Most plug-ins by the Tulip team use an html format to generate help from these informations.
- virtual std::string getRelease () const =0
    The release version of the plug-in, including major and minor. The version should be X.Y, X being the major, and Y the minor.
- virtual std::string getMajor () const =0
    Only the major of the plug-in version. A version should be X.Y, X being the major.
- virtual std::string getMinor () const =0
    Only the minor of the plug-in version. A version should be X.Y, Y being the major.
- virtual std::string getTulipRelease () const =0
    The version of Tulip this plug-in was built with. Tulip versions are X.Y.Z, X eing the major, Y the minor, and Z the patch.
- virtual std::string getTulipMajor () const =0
- virtual std::string getTulipMinor () const =0

## Detailed Description

Base interface for plug-in description. This class is not intented to be subclassed by plug-ins themselves, but by the factories who create the plug-ins. This class holds user informations, such as name of the author, date of creation, and miscellaneous informations. It also holds informations for the Tulip plug-in system, such as the version (used to know when there is an update for a plug-in), the name (used as unique identifier to register the plug-in), the Tulip version the plug-in was built with (to know whether the plug-in is compatible with the currently running version of TUlip), and the group this plug-in belongs to (e.g. trees).

## Constructor & Destructor Documentation

virtual tlp::PluginInfoInterface::~PluginInfoInterface | ( |  | ) | `[inline, virtual]`

## Member Function Documentation

virtual std::string tlp::PluginInfoInterface::getAuthor | ( |  | ) | const`[pure virtual]`

The name of the author of this plug-in.

Returns:
  the name of the author.

Implemented in tlp::AlgorithmPlugin.

virtual std::string tlp::PluginInfoInterface::getDate | ( |  | ) | const`[pure virtual]`

The creation date of the plug-in. This date is in a free format, but most Tulip plug-ins use a DD/MM/YYYY.

Returns:
  the creation date.

Implemented in tlp::AlgorithmPlugin.

virtual std::string tlp::PluginInfoInterface::getGroup | ( |  | ) | const`[pure virtual]`

Returns the name of the group this plug-in belongs to. Groups and sub-groups are separated by two colons. e.g. trees::planar trees.

Returns:
  the group name of this plug-in.

Implemented in tlp::AlgorithmPlugin.

virtual std::string tlp::PluginInfoInterface::getInfo | ( |  | ) | const`[pure virtual]`

Informations about the plug-in, from the plug-in author. These informations can contains anything, and the developer is completely free to put anything here. Most plug-ins by the Tulip team use an html format to generate help from these informations.

Returns:
  string The informations associated with this plug-in.

Implemented in tlp::AlgorithmPlugin.

virtual std::string tlp::PluginInfoInterface::getMajor | ( |  | ) | const`[pure virtual]`

Only the major of the plug-in version. A version should be X.Y, X being the major.

Returns:
  The major part of the plug-in version.

Implemented in tlp::AlgorithmPlugin, tlp::ExportModuleFactory, and tlp::ImportModuleFactory.

virtual std::string tlp::PluginInfoInterface::getMinor | ( |  | ) | const`[pure virtual]`

Only the minor of the plug-in version. A version should be X.Y, Y being the major.

Returns:
  The minor part of the plug-in version.

Implemented in tlp::AlgorithmPlugin, tlp::ExportModuleFactory, and tlp::ImportModuleFactory.

virtual std::string tlp::PluginInfoInterface::getName | ( |  | ) | const`[pure virtual]`

Returns the name of the plug-in, as registered in the Tulip plug-in system. This name must be unique, and if multiple plug-ins have the same name, only the latest encountered will be considered.

Returns:
  string the name of the plug-in.

Implemented in tlp::AlgorithmPlugin.

virtual std::string tlp::PluginInfoInterface::getRelease | ( |  | ) | const`[pure virtual]`

The release version of the plug-in, including major and minor. The version should be X.Y, X being the major, and Y the minor.

Returns:
  string The release version.

Implemented in tlp::AlgorithmPlugin.

virtual std::string tlp::PluginInfoInterface::getTulipMajor | ( |  | ) | const`[pure virtual]`

Returns:
  The major Tulip version the plug-in was built with.

Implemented in tlp::AlgorithmPlugin, tlp::ExportModuleFactory, and tlp::ImportModuleFactory.

virtual std::string tlp::PluginInfoInterface::getTulipMinor | ( |  | ) | const`[pure virtual]`

Returns:
  Return the minor Tulip version this plug-in was built with.

Implemented in tlp::AlgorithmPlugin, tlp::ExportModuleFactory, and tlp::ImportModuleFactory.

virtual std::string tlp::PluginInfoInterface::getTulipRelease | ( |  | ) | const`[pure virtual]`

The version of Tulip this plug-in was built with. Tulip versions are X.Y.Z, X eing the major, Y the minor, and Z the patch.

Returns:
  The Tulip version the plug-in was built with.

Implemented in tlp::AlgorithmPlugin.

Tulip Software by LaBRI Visualization Team 2001 - 2012